﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMotorboat.CollectionGenericObjects;

public interface ICollectionGenericObjects<T>

    where T : class
{
    int Count { get; }
    int MaxCount { get; set; }
    int Insert(T obj);
    int Insert(T obj, int position);
    T Remove(int position);
    T? Get(int position);
    CollectionType GetCollectionType { get; }
    IEnumerable<T> GetItems();
}

