﻿using ProjectMotorboat.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMotorboat.Drownings;
public static class ExtentionDrawningBoat
{
    /// <summary>
    /// Разделитель для записи информации по объекту в файл
    /// </summary>
    private static readonly string _separatorForObject = ":";

    /// <summary>
    /// Создание объекта из строки
    /// </summary>
    /// <param name="info"></param>
    /// <returns></returns>
    public static DrawningBoat? CreateDrawningBoat(this string info)
    {
        string[] strs = info.Split(_separatorForObject);
        EntityBoat? boat = EntityMotorboat.CreateEntityMotorboat(strs);
        if (boat != null)
        {
            return new DrawningMotorboat((EntityMotorboat)boat);
        }

        boat = EntityBoat.CreateEntityBoat(strs);
        if (boat != null)
        {
            return new DrawningBoat(boat);
        }
        return null;
    }

    /// <summary>
    /// Получение данных для сохранения в файл
    /// </summary>
    /// <param name="drawingWarship"></param>
    /// <returns></returns>
    public static string GetDataForSave(this DrawningBoat drawningBoat)
    {
        string[]? array = drawningBoat?.EntityBoat?.GetStringRepresentation();

        if (array == null)
        {
            return string.Empty;
        }

        return string.Join(_separatorForObject, array);
    }
}
